Jump to content
 







Main menu
   


Navigation  



Main page
Contents
Current events
Random article
About Wikipedia
Contact us
Donate
 




Contribute  



Help
Learn to edit
Community portal
Recent changes
Upload file
 








Search  

































Create account

Log in
 









Create account
 Log in
 




Pages for logged out editors learn more  



Contributions
Talk
 



















Contents

   



(Top)
 


1 The problem  



1.1  Example  





1.2  Matrix formulation  





1.3  Bipartite graph formulation  







2 The algorithm in terms of bipartite graphs  



2.1  Proof that the algorithm makes progress  





2.2  Proof that adjusting the potential yleaves Munchanged  





2.3  Proof that yremains a potential  







3 The algorithm in O(n3) time  



3.1  Adding the j-th job in O(jW) time  





3.2  Implementation in C++  







4 Connection to successive shortest paths  





5 Matrix interpretation  



5.1  Step 1  





5.2  Step 2  





5.3  Step 3  





5.4  Step 4  





5.5  Step 5  





5.6  Result  







6 Bibliography  





7 References  





8 External links  



8.1  Implementations  
















Hungarian algorithm






العربية
Català
Deutsch
Español
فارسی
Français
Հայերեն
Bahasa Indonesia
Italiano
עברית
Magyar
Nederlands
Polski
Русский
Simple English
Српски / srpski

Українська

 

Edit links
 









Article
Talk
 

















Read
Edit
View history
 








Tools
   


Actions  



Read
Edit
View history
 




General  



What links here
Related changes
Upload file
Special pages
Permanent link
Page information
Cite this page
Get shortened URL
Download QR code
Wikidata item
 




Print/export  



Download as PDF
Printable version
 
















Appearance
   

 






From Wikipedia, the free encyclopedia
 


The Hungarian method is a combinatorial optimization algorithm that solves the assignment probleminpolynomial time and which anticipated later primal–dual methods. It was developed and published in 1955 by Harold Kuhn, who gave it the name "Hungarian method" because the algorithm was largely based on the earlier works of two Hungarian mathematicians, Dénes Kőnig and Jenő Egerváry.[1][2] However, in 2006 it was discovered that Carl Gustav Jacobi had solved the assignment problem in the 19th century, and the solution had been published posthumously in 1890 in Latin.[3]

James Munkres reviewed the algorithm in 1957 and observed that it is (strongly) polynomial.[4] Since then the algorithm has been known also as the Kuhn–Munkres algorithmorMunkres assignment algorithm. The time complexity of the original algorithm was , however Edmonds and Karp, and independently Tomizawa, noticed that it can be modified to achieve an running time.[5][6] Ford and Fulkerson extended the method to general maximum flow problems in form of the Ford–Fulkerson algorithm.

The problem

[edit]

Example

[edit]

In this simple example, there are three workers: Alice, Bob and Carol. One of them has to clean the bathroom, another sweep the floors and the third washes the windows, but they each demand different pay for the various tasks. The problem is to find the lowest-cost way to assign the jobs. The problem can be represented in a matrix of the costs of the workers doing the jobs. For example:

Task

Worker    

Clean
bathroom
Sweep
floors
Wash
windows
Alice $8 $4 $7
Bob $5 $2 $3
Carol $9 $4 $8

The Hungarian method, when applied to the above table, would give the minimum cost: this is $15, achieved by having Alice clean the bathroom, Carol sweep the floors, and Bob wash the windows. This can be confirmed using brute force:

Clean

Sweep

Alice Bob Carol
Alice $17 $16
Bob $18 $18
Carol $15 $16
(the unassigned person washes the windows)

Matrix formulation

[edit]

In the matrix formulation, we are given an n×n matrix, where the element in the i-th row and j-th column represents the cost of assigning the j-th job to the i-th worker. We have to find an assignment of the jobs to the workers, such that each job is assigned to one worker and each worker is assigned one job, such that the total cost of assignment is minimum.

This can be expressed as permuting the rows of a cost matrix C to minimize the trace of a matrix,

where P is a permutation matrix. (Equivalently, the columns can be permuted using CP.)

If the goal is to find the assignment that yields the maximum cost, the problem can be solved by negating the cost matrix C.

Bipartite graph formulation

[edit]

The algorithm can equivalently be described by formulating the problem using a bipartite graph. We have a complete bipartite graph with n worker vertices (S) and n job vertices (T), and the edges (E) each have a cost . We want to find a perfect matching with a minimum total cost.

The algorithm in terms of bipartite graphs

[edit]

Let us call a function apotentialif for each . The value of potential y is the sum of the potential over all vertices: .

The cost of each perfect matching is at least the value of each potential: the total cost of the matching is the sum of costs of all edges; the cost of each edge is at least the sum of potentials of its endpoints; since the matching is perfect, each vertex is an endpoint of exactly one edge; hence the total cost is at least the total potential.

The Hungarian method finds a perfect matching and a potential such that the matching cost equals the potential value. This proves that both of them are optimal. In fact, the Hungarian method finds a perfect matching of tight edges: an edge is called tight for a potential yif. Let us denote the subgraphoftight edges by . The cost of a perfect matching in (if there is one) equals the value of y.

During the algorithm we maintain a potential y and an orientationof (denoted by ) which has the property that the edges oriented from TtoS form a matching M. Initially, y is 0 everywhere, and all edges are oriented from StoT (soM is empty). In each step, either we modify y so that its value increases, or modify the orientation to obtain a matching with more edges. We maintain the invariant that all the edges of M are tight. We are done if M is a perfect matching.

In a general step, let and be the vertices not covered by M (so consists of the vertices in S with no incoming edge and consists of the vertices in T with no outgoing edge). Let Z be the set of vertices reachable in from by a directed path. This can be computed by breadth-first search.

If is nonempty, then reverse the orientation of all edges along a directed path in from to. Thus the size of the corresponding matching increases by 1.

If is empty, then let

Δ is well defined because at least one such edge must exist whenever the matching is not yet of maximum possible size (see the following section); it is positive because there are no tight edges between and . Increase ybyΔ on the vertices of and decrease ybyΔ on the vertices of . The resulting y is still a potential, and although the graph changes, it still contains M (see the next subsections). We orient the new edges from StoT. By the definition of Δ the set Z of vertices reachable from increases (note that the number of tight edges does not necessarily increase).

We repeat these steps until M is a perfect matching, in which case it gives a minimum cost assignment. The running time of this version of the method is : M is augmented n times, and in a phase where M is unchanged, there are at most n potential changes (since Z increases every time). The time sufficient for a potential change is .

Proof that the algorithm makes progress

[edit]

We must show that as long as the matching is not of maximum possible size, the algorithm is always able to make progress — that is, to either increase the number of matched edges, or tighten at least one edge. It suffices to show that at least one of the following holds at every step:

IfM is of maximum possible size, we are of course finished. Otherwise, by Berge's lemma, there must exist an augmenting path P with respect to M in the underlying graph G. However, this path may not exist in : Although every even-numbered edge in P is tight by the definition of M, odd-numbered edges may be loose and thus absent from . One endpoint of P is in , the other in ; w.l.o.g., suppose it begins in . If every edge on P is tight, then it remains an augmenting path in and we are done. Otherwise, let be the first loose edge on P. If then we have found a loose-tailed path and we are done. Otherwise, v is reachable from some other path Q of tight edges from a vertex in . Let be the subpath of P beginning at v and continuing to the end, and let be the path formed by traveling along Q until a vertex on is reached, and then continuing to the end of . Observe that is an augmenting path in G with at least one fewer loose edge than P. P can be replaced with and this reasoning process iterated (formally, using induction on the number of loose edges) until either an augmenting path in or a loose-tailed path in G is found.

Proof that adjusting the potential y leaves M unchanged

[edit]

To show that every edge in M remains after adjusting y, it suffices to show that for an arbitrary edge in M, either both of its endpoints, or neither of them, are in Z. To this end let be an edge in M from TtoS. It is easy to see that if v is in Z then u must be too, since every edge in M is tight. Now suppose, toward contradiction, that but . u itself cannot be in because it is the endpoint of a matched edge, so there must be some directed path of tight edges from a vertex in tou. This path must avoid v, since that is by assumption not in Z, so the vertex immediately preceding u in this path is some other vertex . is a tight edge from TtoS and is thus in M. But then M contains two edges that share the vertex u, contradicting the fact that M is a matching. Thus every edge in M has either both endpoints or neither endpoint in Z.

Proof that y remains a potential

[edit]

To show that y remains a potential after being adjusted, it suffices to show that no edge has its total potential increased beyond its cost. This is already established for edges in M by the preceding paragraph, so consider an arbitrary edge uv from StoT. If is increased by Δ, then either , in which case is decreased by Δ, leaving the total potential of the edge unchanged, or , in which case the definition of Δ guarantees that . Thus y remains a potential.

The algorithm in O(n3) time

[edit]

Suppose there are jobs and workers (). We describe how to compute for each prefix of jobs the minimum total cost to assign each of these jobs to distinct workers. Specifically, we add the th job and update the total cost in time , yielding an overall time complexity of . Note that this is better than when the number of jobs is small relative to the number of workers.

Adding the j-th job in O(jW) time

[edit]

We use the same notation as the previous section, though we modify their definitions as necessary. Let denote the set of the first jobs and denote the set of all workers.

Before the th step of the algorithm, we assume that we have a matching on that matches all jobs in and potentials satisfying the following condition: the matching is tight with respect to the potentials, and the potentials of all unmatched workers are zero, and the potentials of all matched workers are non-positive. Note that such potentials certify the optimality of the matching.

During the th step, we add the th job to to form and initialize . At all times, every vertex in will be reachable from the th job in . While does not contain a worker that has not been assigned a job, let

and denote any at which the minimum is attained. After adjusting the potentials in the way described in the previous section, there is now a tight edge from to.

Adjusting potentials takes time. Recomputing and after changing the potentials and also can be done in time. Case 1 can occur at most times before case 2 occurs and the procedure terminates, yielding the overall time complexity of .

Implementation in C++

[edit]

For convenience of implementation, the code below adds an additional worker such that stores the negation of the sum of all computed so far. After the th job is added and the matching updated, the cost of the current matching equals the sum of all computed so far, or .

This code is adapted from e-maxx :: algo.[7]

/**
 * Solution to https://open.kattis.com/problems/cordonbleu using Hungarian
 * algorithm.
 */

#include <cassert>
#include <iostream>
#include <limits>
#include <vector>
using namespace std;

/**
 * Sets a = min(a, b)
 * @return true if b <a
 */
template <class T> bool ckmin(T &a, const T &b) { return b < a ? a = b, 1 : 0; }

/**
 * Given J jobs and W workers (J <= W), computes the minimum cost to assign each
 * prefix of jobs to distinct workers.
 *
 * @tparam T a type large enough to represent integers on the order of J *
 * max(|C|)
 * @param C a matrix of dimensions JxW such that C[j][w] = cost to assign j-th
 * job to w-th worker (possibly negative)
 *
 * @return a vector of length J, with the j-th entry equaling the minimum cost
 * to assign the first (j+1) jobs to distinct workers
 */
template <class T> vector<T> hungarian(const vector<vector<T>> &C) {
    const int J = (int)size(C), W = (int)size(C[0]);
    assert(J <= W);
    // job[w] = job assigned to w-th worker, or -1 if no job assigned
    // note: a W-th worker was added for convenience
    vector<int> job(W + 1, -1);
    vector<T> ys(J), yt(W + 1);  // potentials
    // -yt[W] will equal the sum of all deltas
    vector<T> answers;
    const T inf = numeric_limits<T>::max();
    for (int j_cur = 0; j_cur < J; ++j_cur) {  // assign j_cur-th job
        int w_cur = W;
        job[w_cur] = j_cur;
        // min reduced cost over edges from Z to worker w
        vector<T> min_to(W + 1, inf);
        vector<int> prv(W + 1, -1);  // previous worker on alternating path
        vector<bool> in_Z(W + 1);    // whether worker is in Z
        while (job[w_cur] != -1) {   // runs at most j_cur + 1 times
            in_Z[w_cur] = true;
            const int j = job[w_cur];
            T delta = inf;
            int w_next;
            for (int w = 0; w < W; ++w) {
                if (!in_Z[w]) {
                    if (ckmin(min_to[w], C[j][w] - ys[j] - yt[w]))
                        prv[w] = w_cur;
                    if (ckmin(delta, min_to[w])) w_next = w;
                }
            }
            // delta will always be nonnegative,
            // except possibly during the first time this loop runs
            // if any entries of C[j_cur] are negative
            for (int w = 0; w <= W; ++w) {
                if (in_Z[w]) ys[job[w]] += delta, yt[w] -= delta;
                else min_to[w] -= delta;
            }
            w_cur = w_next;
        }
        // update assignments along alternating path
        for (int w; w_cur != W; w_cur = w) job[w_cur] = job[w = prv[w_cur]];
        answers.push_back(-yt[W]);
    }
    return answers;
}

/**
 * Sanity check: https://en.wikipedia.org/wiki/Hungarian_algorithm#Example
 * First job (5):
 *   clean bathroom: Bob ->5
 * First + second jobs (9):
 *   clean bathroom: Bob ->5
 *   sweep floors: Alice ->4
 * First + second + third jobs (15):
 *   clean bathroom: Alice ->8
 *   sweep floors: Carol ->4
 *   wash windows: Bob ->3
 */
void sanity_check_hungarian() {
    vector<vector<int>> costs{{8, 5, 9}, {4, 2, 4}, {7, 3, 8}};
    assert((hungarian(costs) == vector<int>{5, 9, 15}));
    cerr << "Sanity check passed.\n";
}

// solves https://open.kattis.com/problems/cordonbleu
void cordon_bleu() {
    int N, M;
    cin >> N >> M;
    vector<pair<int, int>> B(N), C(M);
    vector<pair<int, int>> bottles(N), couriers(M);
    for (auto &b : bottles) cin >> b.first >> b.second;
    for (auto &c : couriers) cin >> c.first >> c.second;
    pair<int, int> rest;
    cin >> rest.first >> rest.second;
    vector<vector<int>> costs(N, vector<int>(N + M - 1));
    auto dist = [&](pair<int, int> x, pair<int, int> y) {
        return abs(x.first - y.first) + abs(x.second - y.second);
    };
    for (int b = 0; b < N; ++b) {
        for (int c = 0; c < M; ++c) {  // courier -> bottle -> restaurant
            costs[b][c] =
                dist(couriers[c], bottles[b]) + dist(bottles[b], rest);
        }
        for (int _ = 0; _ < N - 1; ++_) {  // restaurant -> bottle -> restaurant
            costs[b][_ + M] = 2 * dist(bottles[b], rest);
        }
    }
    cout << hungarian(costs).back() << "\n";
}

int main() {
    sanity_check_hungarian();
    cordon_bleu();
}

Connection to successive shortest paths

[edit]

The Hungarian algorithm can be seen to be equivalent to the successive shortest path algorithm for minimum cost flow,[8][9] where the reweighting technique from Johnson's algorithm is used to find the shortest paths. The implementation from the previous section is rewritten below in such a way as to emphasize this connection; it can be checked that the potentials for workers are equal to the potentials from the previous solution up to a constant offset. When the graph is sparse (there are only allowed job, worker pairs), it is possible to optimize this algorithm to run in time by using a Fibonacci heap to determine instead of iterating over all workers to find the one with minimum distance (alluded to here).

template <class T> vector<T> hungarian(const vector<vector<T>> &C) {
    const int J = (int)size(C), W = (int)size(C[0]);
    assert(J <= W);
    // job[w] = job assigned to w-th worker, or -1 if no job assigned
    // note: a W-th worker was added for convenience
    vector<int> job(W + 1, -1);
    vector<T> h(W);  // Johnson potentials
    vector<T> answers;
    T ans_cur = 0;
    const T inf = numeric_limits<T>::max();
    // assign j_cur-th job using Dijkstra with potentials
    for (int j_cur = 0; j_cur < J; ++j_cur) {
        int w_cur = W;  // unvisited worker with minimum distance
        job[w_cur] = j_cur;
        vector<T> dist(W + 1, inf);  // Johnson-reduced distances
        dist[W] = 0;
        vector<bool> vis(W + 1);     // whether visited yet
        vector<int> prv(W + 1, -1);  // previous worker on shortest path
        while (job[w_cur] != -1) {   // Dijkstra step: pop min worker from heap
            T min_dist = inf;
            vis[w_cur] = true;
            int w_next = -1;  // next unvisited worker with minimum distance
            // consider extending shortest path by w_cur -> job[w_cur] ->w
            for (int w = 0; w < W; ++w) {
                if (!vis[w]) {
                    // sum of reduced edge weights w_cur -> job[w_cur] ->w
                    T edge = C[job[w_cur]][w] - h[w];
                    if (w_cur != W) {
                        edge -= C[job[w_cur]][w_cur] - h[w_cur];
                        assert(edge >= 0);  // consequence of Johnson potentials
                    }
                    if (ckmin(dist[w], dist[w_cur] + edge)) prv[w] = w_cur;
                    if (ckmin(min_dist, dist[w])) w_next = w;
                }
            }
            w_cur = w_next;
        }
        for (int w = 0; w < W; ++w) {  // update potentials
            ckmin(dist[w], dist[w_cur]);
            h[w] += dist[w];
        }
        ans_cur += h[w_cur];
        for (int w; w_cur != W; w_cur = w) job[w_cur] = job[w = prv[w_cur]];
        answers.push_back(ans_cur);
    }
    return answers;
}

Matrix interpretation

[edit]

This variant of the algorithm follows the formulation given by Flood,[10] and later described more explicitly by Munkres, who proved it runs in time.[4] Instead of keeping track of the potentials of the vertices, the algorithm operates only on a matrix:

where is the original cost matrix and are the potentials from the graph interpretation. Changing the potentials corresponds to adding or subtracting from rows or columns of this matrix. The algorithm starts with . As such, it can be viewed as taking the original cost matrix and modifying it.

Given n workers and tasks, the problem is written in the form of an n×n cost matrix

a1a2a3a4
b1b2b3b4
c1c2c3c4
d1d2d3d4

where a, b, c and d are workers who have to perform tasks 1, 2, 3 and 4. a1, a2, a3, and a4 denote the penalties incurred when worker "a" does task 1, 2, 3, and 4 respectively.

The problem is equivalent to assigning each worker a unique task such that the total penalty is minimized. Note that each task can only be worked on by one worker.

Step 1

[edit]

For each row, its minimum element is subtracted from every element in that row. This causes all elements to have nonnegative values. Therefore, an assignment with a total penalty of 0 is by definition a minimum assignment.

This also leads to at least one zero in each row. As such, a naive greedy algorithm can attempt to assign all workers a task with a penalty of zero. This is illustrated below.

0a2a3a4
b1b2b3 0
c1 0c3c4
d1d2 0d4

The zeros above would be the assigned tasks.

Worst-case there are n! combinations to try, since multiple zeroes can appear in a row if multiple elements are the minimum. So at some point this naive algorithm should be short circuited.

Step 2

[edit]

Sometimes it may turn out that the matrix at this stage cannot be used for assigning, as is the case for the matrix below.

0a2 0a4
b1 0b3 0
0c2c3c4
0d2d3d4

To overcome this, we repeat the above procedure for all columns (i.e. the minimum element in each column is subtracted from all the elements in that column) and then check if an assignment with penalty 0 is possible.

In most situations this will give the result, but if it is still not possible then we need to keep going.

Step 3

[edit]

All zeros in the matrix must be covered by marking as few rows and/or columns as possible. Steps 3 and 4 form one way to accomplish this.

For each row, try to assign an arbitrary zero. Assigned tasks are represented by starring a zero. Note that assignments can't be in the same row or column.

We could end with another assignment if we choose another ordering of the rows and columns.

0*a2 0a4
b1 0*b3 0
0c2c3c4
0d2d3d4

Step 4

[edit]

Cover all columns containing a (starred) zero.

× ×
0* a2 0 a4
b1 0* b3 0
0 c2 c3 c4
0 d2 d3 d4

Find a non-covered zero and prime it (mark it with a prime symbol). If no such zero can be found, meaning all zeroes are covered, skip to step 5.

×
0* a2 0' a4 ×
b1 0* b3 0
0 c2 c3 c4
0 d2 d3 d4
0* a2 0' a4 ×
b1 0* b3 0' ×
0 c2 c3 c4
0 d2 d3 d4

The zero on Row 3 is uncovered. We add to the path the first zero of Row 1, then the second zero of Row 1, then we are done.

0* a2 0' a4 ×
b1 0* b3 0' ×
0' c2 c3 c4
0 d2 d3 d4
0 a2 0* a4
b1 0* b3 0
0* c2 c3 c4
0 d2 d3 d4
× ×
0 a2 0* a4
b1 0* b3 0' ×
0* c2 c3 c4
0 d2 d3 d4

All zeros are now covered with a minimal number of rows and columns.

The aforementioned detailed description is just one way to draw the minimum number of lines to cover all the 0s. Other methods work as well.

Step 5

[edit]

If the number of starred zeros is n (or in the general case , where n is the number of people and m is the number of jobs), the algorithm terminates. See the Result subsection below on how to interpret the results.

Otherwise, find the lowest uncovered value. Subtract this from every unmarked element and add it to every element covered by two lines. Go back to step 4.

This is equivalent to subtracting a number from all rows which are not covered and adding the same number to all columns which are covered. These operations do not change optimal assignments.

Result

[edit]

If following this specific version of the algorithm, the starred zeros form the minimum assignment.

From Kőnig's theorem,[11] the minimum number of lines (minimum vertex cover[12]) will be n (the size of maximum matching[13]). Thus, when n lines are required, minimum cost assignment can be found by looking at only zeroes in the matrix.

Bibliography

[edit]

References

[edit]
  1. ^ Harold W. Kuhn, "The Hungarian Method for the assignment problem", Naval Research Logistics Quarterly, 2: 83–97, 1955. Kuhn's original publication.
  • ^ Harold W. Kuhn, "Variants of the Hungarian method for assignment problems", Naval Research Logistics Quarterly, 3: 253–258, 1956.
  • ^ "Presentation". Archived from the original on 16 October 2015.
  • ^ a b J. Munkres, "Algorithms for the Assignment and Transportation Problems", Journal of the Society for Industrial and Applied Mathematics, 5(1):32–38, 1957 March.
  • ^ Edmonds, Jack; Karp, Richard M. (1 April 1972). "Theoretical Improvements in Algorithmic Efficiency for Network Flow Problems". Journal of the ACM. 19 (2): 248–264. doi:10.1145/321694.321699. S2CID 6375478.
  • ^ Tomizawa, N. (1971). "On some techniques useful for solution of transportation network problems". Networks. 1 (2): 173–194. doi:10.1002/net.3230010206. ISSN 1097-0037.
  • ^ "Hungarian Algorithm for Solving the Assignment Problem". e-maxx :: algo. 23 August 2012. Retrieved 13 May 2023.
  • ^ Jacob Kogler (20 December 2022). "Minimum-cost flow - Successive shortest path algorithm". Algorithms for Competitive Programming. Retrieved 14 May 2023.
  • ^ "Solving assignment problem using min-cost-flow". Algorithms for Competitive Programming. 17 July 2022. Retrieved 14 May 2023.
  • ^ Flood, Merrill M. (1956). "The Traveling-Salesman Problem". Operations Research. 4 (1): 61–75. doi:10.1287/opre.4.1.61. ISSN 0030-364X.
  • ^ Kőnig's theorem (graph theory) Konig's theorem
  • ^ Vertex cover minimum vertex cover
  • ^ Matching (graph theory) matching
  • [edit]

    Implementations

    [edit]

    Note that not all of these satisfy the time complexity, even if they claim so. Some may contain errors, implement the slower algorithm, or have other inefficiencies. In the worst case, a code example linked from Wikipedia could later be modified to include exploit code. Verification and benchmarking is necessary when using such code examples from unknown authors.



    Retrieved from "https://en.wikipedia.org/w/index.php?title=Hungarian_algorithm&oldid=1235721596"

    Categories: 
    Matching (graph theory)
    Combinatorial optimization
    Hidden categories: 
    Articles with short description
    Short description is different from Wikidata
    Use dmy dates from April 2020
     



    This page was last edited on 20 July 2024, at 21:31 (UTC).

    Text is available under the Creative Commons Attribution-ShareAlike License 4.0; additional terms may apply. By using this site, you agree to the Terms of Use and Privacy Policy. Wikipedia® is a registered trademark of the Wikimedia Foundation, Inc., a non-profit organization.



    Privacy policy

    About Wikipedia

    Disclaimers

    Contact Wikipedia

    Code of Conduct

    Developers

    Statistics

    Cookie statement

    Mobile view



    Wikimedia Foundation
    Powered by MediaWiki